// Code generated by smithy-go-codegen DO NOT EDIT.

package databasemigrationservice

import (
	"context"
	awsmiddleware "github.com/aws/aws-sdk-go-v2/aws/middleware"
	"github.com/aws/aws-sdk-go-v2/aws/signer/v4"
	"github.com/aws/smithy-go/middleware"
	smithyhttp "github.com/aws/smithy-go/transport/http"
)

// Runs large-scale assessment (LSA) analysis on every Fleet Advisor collector in
// your account.
func (c *Client) RunFleetAdvisorLsaAnalysis(ctx context.Context, params *RunFleetAdvisorLsaAnalysisInput, optFns ...func(*Options)) (*RunFleetAdvisorLsaAnalysisOutput, error) {
	if params == nil {
		params = &RunFleetAdvisorLsaAnalysisInput{}
	}

	result, metadata, err := c.invokeOperation(ctx, "RunFleetAdvisorLsaAnalysis", params, optFns, c.addOperationRunFleetAdvisorLsaAnalysisMiddlewares)
	if err != nil {
		return nil, err
	}

	out := result.(*RunFleetAdvisorLsaAnalysisOutput)
	out.ResultMetadata = metadata
	return out, nil
}

type RunFleetAdvisorLsaAnalysisInput struct {
	noSmithyDocumentSerde
}

type RunFleetAdvisorLsaAnalysisOutput struct {

	// The ID of the LSA analysis run.
	LsaAnalysisId *string

	// The status of the LSA analysis, for example COMPLETED.
	Status *string

	// Metadata pertaining to the operation's result.
	ResultMetadata middleware.Metadata

	noSmithyDocumentSerde
}

func (c *Client) addOperationRunFleetAdvisorLsaAnalysisMiddlewares(stack *middleware.Stack, options Options) (err error) {
	err = stack.Serialize.Add(&awsAwsjson11_serializeOpRunFleetAdvisorLsaAnalysis{}, middleware.After)
	if err != nil {
		return err
	}
	err = stack.Deserialize.Add(&awsAwsjson11_deserializeOpRunFleetAdvisorLsaAnalysis{}, middleware.After)
	if err != nil {
		return err
	}
	if err = addSetLoggerMiddleware(stack, options); err != nil {
		return err
	}
	if err = awsmiddleware.AddClientRequestIDMiddleware(stack); err != nil {
		return err
	}
	if err = smithyhttp.AddComputeContentLengthMiddleware(stack); err != nil {
		return err
	}
	if err = addResolveEndpointMiddleware(stack, options); err != nil {
		return err
	}
	if err = v4.AddComputePayloadSHA256Middleware(stack); err != nil {
		return err
	}
	if err = addRetryMiddlewares(stack, options); err != nil {
		return err
	}
	if err = addHTTPSignerV4Middleware(stack, options); err != nil {
		return err
	}
	if err = awsmiddleware.AddRawResponseToMetadata(stack); err != nil {
		return err
	}
	if err = awsmiddleware.AddRecordResponseTiming(stack); err != nil {
		return err
	}
	if err = addClientUserAgent(stack); err != nil {
		return err
	}
	if err = smithyhttp.AddErrorCloseResponseBodyMiddleware(stack); err != nil {
		return err
	}
	if err = smithyhttp.AddCloseResponseBodyMiddleware(stack); err != nil {
		return err
	}
	if err = stack.Initialize.Add(newServiceMetadataMiddleware_opRunFleetAdvisorLsaAnalysis(options.Region), middleware.Before); err != nil {
		return err
	}
	if err = addRequestIDRetrieverMiddleware(stack); err != nil {
		return err
	}
	if err = addResponseErrorMiddleware(stack); err != nil {
		return err
	}
	if err = addRequestResponseLogging(stack, options); err != nil {
		return err
	}
	return nil
}

func newServiceMetadataMiddleware_opRunFleetAdvisorLsaAnalysis(region string) *awsmiddleware.RegisterServiceMetadata {
	return &awsmiddleware.RegisterServiceMetadata{
		Region:        region,
		ServiceID:     ServiceID,
		SigningName:   "dms",
		OperationName: "RunFleetAdvisorLsaAnalysis",
	}
}
